#include <bits/stdc++.h>
#include <vector>

using namespace std;

int main()
{
    int da = 1;
    int n;
    cin >> n;
    int o, a, b, ab;

    cin >> o >> a >> b >> ab;

    vector<string> grupa;
    int *kolko = (int*)calloc(n, sizeof(int));
    int *rezultati = (int*)calloc(n*4, sizeof(int));
    for (int i = 0; i < n*4; i++) {
        rezultati[i] = 0;
    }

    for (int i = 0; i < n; i++){
        string temp;
        cin >> temp >> kolko[i];
        grupa.push_back(temp);
    }

    int oc = o, ac = a, bc = b, abc = ab;

    for (int i = 0; i < n; i++) {
        if (grupa[i] == "O") {
            if (kolko[i] <= oc) {
                oc -= kolko[i];
                rezultati[i*4] = kolko[i];
            } else {
                da = 0;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (grupa[i] == "A") {
            if (kolko[i] <= ac) {
                ac -= kolko[i];
                rezultati[i*4+1] = kolko[i];
            } else if(kolko[i] <= ac+oc) {
                int temp = kolko[i] - ac;
                ac = 0;
                rezultati[i*4+1] = kolko[i] - temp;
                oc -= temp;
                rezultati[i*4] = temp;
            } else {
                    da = 0;
                }
            }
    }

    for (int i = 0; i < n; i++) {
        if (grupa[i] == "B") {
            if (kolko[i] <= bc) {
                bc -= kolko[i];
                rezultati[i*4+2] = kolko[i];
            } else if(kolko[i] <= bc+oc) {
                int temp = kolko[i] - bc;
                rezultati[i*4+2] = kolko[i] - temp;
                bc = 0;
                oc -= temp;
                rezultati[i*4] = temp;
            } else {
                da = 0;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (grupa[i] == "AB") {
            if (kolko[i] <= ac+bc+oc+abc) {
                int temp = kolko[i];
                while (temp > 0) {
                    if (oc >= temp) {
                        oc -= temp;
                        rezultati[i*4] = temp;
                        break;
                    } else {
                        int temp2 = oc;
                        oc = 0;
                        temp -= temp2;
                        rezultati[i*4] = temp2;
                    }

                    if (ac >= temp) {
                        ac -= temp;
                        rezultati[i*4+1] = temp;
                        break;
                    } else {
                        int temp2 = ac;
                        ac = 0;
                        temp -= temp2;
                        rezultati[i*4+1] = temp2;
                    }

                    if (bc >= temp) {
                        bc -= temp;
                        rezultati[i*4+2] = temp;
                        break;
                    } else {
                        int temp2 = bc;
                        bc = 0;
                        temp -= temp2;
                        rezultati[i*4+2] = temp2;
                    }

                    if (abc >= temp) {
                        abc -= temp;
                        rezultati[i*4+3] = temp;
                        break;
                    } else {
                        int temp2 = abc;
                        abc = 0;
                        temp -= abc;
                        rezultati[i*4+3] = temp2;
                    }
                }
            } else {
                da = 0;
            }
        }
    }

    if (da == 0) {
        cout << "nemoguce";
    } else {
        cout << "moguce" << endl;
        for (int i = 0; i < n*4; i += 4) {
            cout << rezultati[i] << " " << rezultati[i+1] << " " << rezultati[i+2] << " " << rezultati[i+3] << endl;
        }
    }
    return 0;
}